"use strict";
// 参数1 方法名
// 参数2 传入参数 (json格式)
// 参数3 回调 (json格式)
var yike = {
    isNative: (window.nativeHandler),
    handler: function () {
        var hand = {
            execute: function () { },
            ami: "h5"
        };
        if (window.nativeHandler) {
            hand = window.nativeHandler;
            hand.ami = 'native';
        }
        return hand;
    },

    // 关闭当前
    closeWebview: function () {
        this.handler().execute("closeThisWebView", "", "");
    },

    newWebview: function (e) {
        this.handler().execute("popupWebView", JSON.stringify({
            statusBarStyle: 0,
            url: e,
            ref: ""
        }), "");
    },

    // 登录
    login: function () {
        this.handler().execute("popupToLogin", "request", "");
    },

    // 登录状态监听
    listenSignStatus: function (cb) {
        window.loginStateChangeCallback = function (data) {
            cb && cb(data);
        };
        this.handler().execute("registerLoginStateChange", "request", JSON.stringify({
            notice: "loginStateChangeCallback"
        }));
    },

    // 当前个人信息
    getUserInfo: function () {
        var e = {
            getGuid: function () { },
            getAppid: function () { },
            getAvatarUrl: function () { },
            getNickName: function () { },
            getToken: function () { }
        };

        return this.handler().execute("getUserInfo", "request", "") || e;
    },

    // 当前设备信息
    getDeviceInfo: function () {
        try {
            var e = {
                getOs: function () { },
                getVersion: function () { },
                getBrand: function () { },
                getToken: function () { },
                getDeviceId: function () { },
                getPublishid: function () { },
                getScreen: function () { },
                getImei: function () { },
                getIdfa: function () { },
                getWifiMac: function () { },
                getNetModel: function () { }
            };
            return this.handler().execute("getDeviceInfo", "request", "") || e;
        } catch (t) { }
    },

    // 获取地理位置
    getLocation: function () {
        try {
            var e = {
                getLatitudeString: function () { },
                getLongitudeString: function () { }
            };
            return this.handler().execute("getLocation", "", "") || e;
        } catch (t) { }
    },

    // 加密
    getSecParams: function (e) {
        try {
            return this.handler().execute("getSecParams", JSON.stringify(e), "").getResult();
        } catch (t) { }
    },

    bindWechat: function (e) {
        window.bindingWeixinCallback = function (t) {
            e && e(t);
        };
        this.handler().execute("bindingWeixin", "", JSON.stringify({
            success: "bindingWeixinCallback"
        })).getResult();
    },

    bindGuestPhone: function (e) {
        try {
            return this.handler().execute("bindGuestPhone", JSON.stringify({
                ref: e.ref
            }), "");
        } catch (t) { }
    },

    onSendMsg: function (msg) {
        console.log("onSendMsg: ", msg);
        this.handler().execute('onSendMsg', JSON.stringify(msg), '');
    },

    // 打开或关闭 banner
    setBanner: function (id, token, requestId, event) {
        this.handler().execute('setBanner', JSON.stringify({
            id: id,
            token: token,
            requestId: requestId,
            event: event
        }), '');
    },
    // 打开 插屏广告
    showInters: function (id, token, requestId) {
        this.handler().execute('showInters', JSON.stringify({
            id: id,
            token: token,
            requestId: requestId
        }), '');
        console.log("showInters", id, token, requestId);
    },

    loadRewardVideoAndPlay: function (id, token, requestId, i) {
        window.videoPlayComplete = function (e) {
            i && i(e);
        };
        try {
            return this.handler().execute("loadRewardVideoAndPlay", JSON.stringify({
                id: id,
                token: token,
                requestId: requestId
            }), JSON.stringify({
                complete: "videoPlayComplete"
            }));
        } catch (c) { }
    },

    clearRewardVideo: function () {
        try {
            return this.handler().execute("clearRewardVideo", "", "");
        } catch (e) { }
    },

    // 客户端加金币
    clientCoinDialog: function (msg, cb) {
        window.buttonClick = function (e) {
            console.log('lhb buttonClick:' + JSON.stringify(e));
            cb && cb(e);
        };
        try {
            this.handler().execute('clientCoinDialog', JSON.stringify(msg), JSON.stringify({
                buttonClick: "buttonClick"
            }));
        } catch (e) { }
    },

    onJump: function (id) {
        this.handler().execute('jump', JSON.stringify({
            type: 'main',
            id: id
        }), '');
    },
    showCoinDialogAd: function (coin,pageId,msg){
        this.handler().execute('showCoinDialogAd', JSON.stringify({
            coin: coin,
            pageId: pageId,
            tips: msg['tips'],
            btnDesc: msg['btnDesc'],
            cancelDesc: msg['cancelDesc'],
        }), '');
        console.log("--------",msg);
    }
};
window.yike = yike;